/*
 () 
e-mail: liloi@mail.ru
08/04/06

e_vst_x(...) - e   x
sin_x(...) - sin  x
cos_x(...) - cos  x

*/

#include <iostream.h>
#include <math.h>


void e_vst_x(double x, double eps)
{
	double s, a, n;
	s = a = n = 1;
	
	cout << endl;
	
	cout << "S = (" << s << ") + (";
	
	while(eps<fabs(a))
	{
		a *= x/n; 
		
		/*
		 ^:     n-1   :
		    (n-1) ,   (n) .  
		  n.
		*/
		cout << a << ") + (";
		
		s += a;
		n++;
	}
	
	cout << "0)" << endl << endl;
	
	cout << "e^" << x << " = " << s << endl;
	cout << "e^" << x << " = " << exp(x) << endl;
}


void sin_x(double x, double eps)
{
	double s, a, n;
	s = x;
	a = n = 1;
	
	cout << endl;
	
	cout << "S = (" << s << ") + (";
	
	while(eps<fabs(a))
	{
		a *= ((-1)*pow(x,2))/((2*n)*(2*n+1));
		
		cout << a << ") + (";
		
		s += a;
		n++;
	}
	
	cout << "0)" << endl << endl;
	
	cout << "sin(" << x << " ) = " << s << endl;
	cout << "sin(" << x << " ) = " << sin(x) << endl;
}

void cos_x(double x, double eps)
{
	double s, a, n;
	s = a = n = 1;
	
	cout << endl;
	
	cout << "S = (" << s << ") + (";
	
	while(eps<fabs(a))
	{
		a *= ((-1)*pow(x,2))/((2*n-1)*(2*n));
		
		cout << a << ") + (";
		
		s += a;
		n++;
	}
	
	cout << "0)" << endl << endl;
	
	cout << "cos(" << x << " ) = " << s << endl;
	cout << "cos(" << x << " ) = " << cos(x) << endl;
}


int main(int argc, char *argv[])
{
	double x, eps;

	cout << " X ->  ";
	cin >> x;
	
	cout << "  ->  "; // : 0.0001.     ,   
	cin >> eps;
	
	e_vst_x(x, eps);
	
	return 0;
}

//
